FilteredDocIdSetIterator (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.FilteredDocIdSetIterator class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class FilteredDocIdSetIterator

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.search.FilteredDocIdSetIterator

    public abstract class FilteredDocIdSetIterator

extends DocIdSetIterator

Abstract decorator class of a DocIdSetIterator implementation that provides on-demand filter/validation mechanism on an underlying DocIdSetIterator. See `FilteredDocIdSet`.

Field Summary
`protected DocIdSetIterator` | `_innerIter`

Fields inherited from class org.apache.lucene.search.DocIdSetIterator
`NO_MORE_DOCS`

Constructor Summary
`FilteredDocIdSetIterator(DocIdSetIterator innerIter)` Constructor.

Method Summary
`int` | `advance(int target)` Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target.
`int` | `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`protected abstract boolean` | `match(int doc)` Validation method to determine whether a docid should be in the result set.
`int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _innerIter

    protected DocIdSetIterator _innerIter

Constructor Detail

### FilteredDocIdSetIterator

    public FilteredDocIdSetIterator(DocIdSetIterator innerIter)

  Constructor.

  Parameters:
    `innerIter` - Underlying DocIdSetIterator.

Method Detail

### match

    protected abstract boolean match(int doc)
                              throws IOException

  Validation method to determine whether a docid should be in the result set.

  Parameters:
    `doc` - docid to be tested
  Returns:
    true if input docid should be in the result set, false otherwise.
  Throws:
    `IOException`
  See Also:
    `FilteredDocIdSetIterator(DocIdSetIterator)`

### docID

    public int docID()

  Description copied from class: `DocIdSetIterator`
  Returns the following:
  - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  Specified by:
    `docID` in class `DocIdSetIterator`

### nextDoc

    public int nextDoc()
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `nextDoc` in class `DocIdSetIterator`
  Throws:
    `IOException`

### advance

    public int advance(int target)
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target. Returns the current document number or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.

  Behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: when `target ≤ current` implementations may opt not to advance beyond their current `DocIdSetIterator.docID()`.

  NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `advance` in class `DocIdSetIterator`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD